#module
#uselib "user32.dll"
#func IsClipboardFormatAvailable	"IsClipboardFormatAvailable"	sptr
#func OpenClipboard					"OpenClipboard" 				sptr
#func CloseClipboard				"CloseClipboard"
#func GetClipboardData 				"GetClipboardData"				sptr
#func EmptyClipboard				"EmptyClipboard"
#func SetClipboardData				"SetClipboardData"				sptr,sptr

#uselib "kernel32.dll"
#func GlobalAlloc		"GlobalAlloc"	sptr,sptr
#func GlobalLock		"GlobalLock"	sptr
#func GlobalUnlock		"GlobalUnlock"	sptr
#func GlobalFree		"GlobalFree"	sptr
#func GlobalSize		"GlobalSize"	sptr

#define CF_DIB			0x00000008
#define CF_PRIVATEFIRST	0x00000200
#define CF_PRIVATES		0x00000210
#define GHND			0x00000042;GMEM_MOVEABLE |GMEM_ZEROINIT
#define GMEM_SHARE		0x00002000

#deffunc clipset
	ret = 0

	mref VRAM , 66
	mref BMSCR, 67

	infsize = BMSCR.15;        // *pbi alloc memory size
	bmpsize = BMSCR.16;        // *pBit alloc memory size
	size =  infsize +  bmpsize
	dupptr pbi , BMSCR.6 , infsize , 2
	size_private = 4096

	;O[o쐬AbN
	GlobalAlloc GHND|GMEM_SHARE , size : hClip = stat
	GlobalLock hClip                   : pBmp  = stat

	;O[oɃRs[
	dupptr data , pBmp , size , 2
	memcpy data , pbi  , infsize
	memcpy data , VRAM , bmpsize , infsize

	;bN̉
	GlobalUnlock hClip

	;Nbv{[hJ
	OpenClipboard hwnd
	if stat{
		;Nbv{[hɂ
		EmptyClipboard
		;Nbv{[hɒlݒ肷
		SetClipboardData CF_DIB, hClip
		;Nbv{[h
		CloseClipboard
		return 1
	}
	;O[oO
	GlobalFree hClip

	return 0

#deffunc clipsetp
	ret = 0
	size_private = 4096

	GlobalAlloc GHND|GMEM_SHARE , size_private : hClip_private = stat
	GlobalLock hClip_private                   : pMem_private  = stat

	dupptr data_private , pMem_private , size_private , 2
	memcpy data_private , param , 4096

	GlobalUnlock hClip_private
	
	OpenClipboard hwnd
	if stat{
		SetClipboardData CF_PRIVATES , hClip_private
		CloseClipboard
		return 1
	}
	GlobalFree hClip_private

	return 1

#deffunc clipget
	;߂lZbg
	ret = 0
	;DIB݂̑
	IsClipboardFormatAvailable CF_DIB
	if( stat == 0 ): return

	;Nbv{[hJ
	OpenClipboard hwnd
	if( stat == 0 ): return

	;IuWFNg̃nh擾
	GetClipboardData CF_DIB
	hClip = stat
	
	if hClip{
		; TCY擾
		GlobalSize hClip  
		size = stat
		if size{
			sdim dib, size
			;Nbv{[h̃f[^ǂݍ
			dupptr data, hClip, size, 2
			;Nbv{[h̃f[^ϐɕۑ
			memcpy dib, data, size

			;BITMAPINFOHEADER
			w   = lpeek( dib ,  4 )
			h   = lpeek( dib ,  8 )
			bit = wpeek( dib , 14 )

			;8bit̂
			if bit = 8{
				;obt@̍쐬
				rvar = ginfo_sel
				buffer rvar , w , h , screen_palette
				mref clip_vram , 66
				mref BMSCR, 67
				;rbg}bvobt@ɃRs[
				memcpy clip_vram , dib , BMSCR.16 , 0 , 1064
				;pbgݒ
				i = 40
				repeat 256
					palette cnt , peek( dib , i + 2 ) , peek( dib , i + 1 ) , peek( dib , i ) , cnt = 255
					i += 4
				loop
				
				ret = 1
			}
		}
	}
	;Nbv{[h
	CloseClipboard

	return ret

#deffunc clipgetp
	;߂lZbg
	ret = 0
	dim s_param , 108
	;DIB݂̑
	IsClipboardFormatAvailable CF_PRIVATES
	if( stat == 0 ): return

	;Nbv{[hJ
	OpenClipboard hwnd
	if( stat == 0 ): return

	;IuWFNg̃nh擾
	GetClipboardData CF_PRIVATES
	hClip = stat
	
	if hClip{
		; TCY擾
		GlobalSize hClip  
		size = stat
		if size{
			sdim param , size
			sdim header , 8
			;Nbv{[h̃f[^ǂݍ
			dupptr data, hClip, size, 2
			;Nbv{[h̃f[^ϐɕۑ
			memcpy param , data , size
			memcpy header , data , 8
			
			if header  = "repaClip"{
				ret = 1
			}else{
				ret = 0
			}
		}
	}
	;Nbv{[h
	CloseClipboard

	return ret

#defcfunc getParam int no
	return lpeek( param , no *  4 +  8)

#defcfunc getAnime_x int no
	return lpeek( param , no * 12 + 48)

#defcfunc getAnime_y int no
	return lpeek( param , no * 12 + 52)

#defcfunc getAnime_time int no
	return lpeek( param , no * 12 + 56)

#deffunc setPasteStatus int val
	lpoke param , 8 , val
	return

#global

#enum PASTE_STATUS = 0
#enum SELECT_PALETTE
#enum COPY_POS_X
#enum COPY_POS_Y
#enum FOCUS_STATUS
#enum COPY_STATUS
#enum ANIME_NO
#enum ANIME_COUNT
#enum ANIME_WIDTH
#enum ANIME_HIGHT
